
local motiondetector = {}

function motiondetector.create(object)
	object.update = motiondetector.update
	object.setstate = motiondetector.setstate

	object.offgid = object.gid
	object.ongid = object.gid + 1
end

function motiondetector:update(dt)
	local numberofmatches = 0

	for _, area in ipairs(self.incoming_links or {}) do
		if not area.type then
			local matches = hajtech.collision.overlapWithEntity(area, 'character')
			numberofmatches = numberofmatches + #matches
		end
	end

	self.gid = (numberofmatches > 0) and self.ongid or self.offgid

	for _, target in ipairs(self.outgoing_links or {}) do
		if target.setstate then
			target:setstate(numberofmatches > 0)
		end
	end
end

function motiondetector:setstate(state)
	if state then
		-- for _, target in ipairs(self.outgoing_links or {}) do
		-- 	if target.setstate then
		-- 		target:setstate(false)
		-- 	end
		-- end
		self.update = nil
	else
		self.update = motiondetector.update
	end
end

return motiondetector
