
local screenexit = {}

function screenexit.create(object)
	object.draw = screenexit.draw
	object.update = screenexit.update
	object.currentmatched = 0
end

function screenexit:draw()
	love.graphics.setColor(love.math.colorFromBytes(160, 151, 48))
	if self.currentmatched > 0 then
		love.graphics.printf(self.currentmatched .. "/3", self.x, self.y, self.w, 'center')
	end
	love.graphics.setColor(1, 1, 1)
end

function screenexit:update(dt)
	self.currentmatched = 0
	local matches = hajtech.collision.overlapWithEntity(self, 'character')
	for i, match in ipairs(matches) do
		self.currentmatched = self.currentmatched + 1
	end
	if self.currentmatched >= 3 then
		hajtech.transition.fade(1, 2, hajtech.gameendscreen.enter)
	end
end

return screenexit
