
local throwable = {}

function throwable.create(object)
	object.update = throwable.update

	object.xspeed = 0
	object.yspeed = 0
	object.onground = false

	object.properties.throwable = true
end

function throwable:update(dt)
	if hajtech.collision.moveY(self, self.yspeed*dt) then
		if self.yspeed > 0 then
			self.onground = true
		end
		self.yspeed = 0
	else
		self.onground = false
	end
	if hajtech.collision.moveX(self, self.xspeed*dt) then
		self.xspeed = 0
	end

	local dspeed = 0 - self.xspeed
	local speedchange
	if self.onground then
		speedchange = 2000*dt
	else
		speedchange = 200*dt
	end
	dspeed = clamp(dspeed, speedchange)
	self.xspeed = self.xspeed + dspeed

	-- Apply gravity
	self.yspeed = math.min(256, self.yspeed + 900*dt)
end

return throwable
