
local tutorialtext = {}

local icons_image = love.graphics.newImage("img/controllericons.png")

local gamepad_icons = {
	a = love.graphics.newQuad(0, 0, 20, 20, 160, 20),
	b = love.graphics.newQuad(20, 0, 20, 20, 160, 20),
	x = love.graphics.newQuad(40, 0, 20, 20, 160, 20),
	y = love.graphics.newQuad(60, 0, 20, 20, 160, 20),
}

function tutorialtext.create(object)
	object.draw = tutorialtext.draw
end

function tutorialtext:draw()
	local text = self.properties.text
	text = string.gsub(text, "\\n", "\n")
	local keytext = self.properties.key

	if keytext then
		local playerbinds = hajtech.input.playerbindings[hajtech.currentplayer]
		if playerbinds then
			if playerbinds.gamepad then
				local button = playerbinds.action2key[keytext]
				keytext = button or ""
				if gamepad_icons[keytext] then
					love.graphics.draw(icons_image, gamepad_icons[keytext], self.x + 6, self.y + 6)
					return
				end
			else
				local scancode = playerbinds.action2key[keytext]
				keytext = love.keyboard.getKeyFromScancode(scancode)
			end

			text = string.format(text, keytext)
			love.graphics.printf(text, self.x, self.y, self.w, 'center')
		end
	else
		love.graphics.printf(text, self.x, self.y, self.w, 'center')
	end
end

return tutorialtext
