
local ventilation = {}

function ventilation.create(object)
	object.disabled = object.properties.disabled
	object.properties.usable = true
	object.use = ventilation.use
	object.gettarget = ventilation.gettarget
end

function ventilation:gettarget()
	local target = self.outgoing_links and self.outgoing_links[1]
	return target or (self.incoming_links and self.incoming_links[1])
end

function ventilation:use(user)
	if self.disabled then return end
	if not user.properties.ventilatable then return end

	local target = self:gettarget()

	if not target then return end
	if not user.visible then return end

	user.visible = false
	local old_update = user.update

	local speed = self.properties.speed or 96

	user.update = function(self, dt)
		local dx = target.x + target.w/2 - (self.x + self.w/2)
		local dy = target.y + target.h/2 - (self.y + self.h/2)
		self.x = self.x + clamp(dx, speed*dt)
		self.y = self.y + clamp(dy, speed*dt)

		if dx == 0 and dy == 0 then
			self.visible = true
			self.update = old_update

			if target.disabled then
				target.disabled = false
				if target.gid then
					target.gid = target.gid + 1
				end
			end
			self.xspeed = 10
			self.yspeed = -80
		end
	end
end

return ventilation
