
local gameendscreen = {}

local oldfunctions = {}

local image = love.graphics.newImage('img/sunscreen.png')
local countdown

function gameendscreen.enter()
	oldfunctions.draw = love.draw
	oldfunctions.update = love.update
	oldfunctions.keypressed = love.keypressed
	oldfunctions.touchmoved = love.touchmoved
	oldfunctions.handleInput = handleInput

	love.draw = gameendscreen.draw
	love.update = gameendscreen.update
	love.keypressed = gameendscreen.keypressed
	love.touchmoved = nil
	handleInput = gameendscreen.handleInput

	countdown = 5
end

function gameendscreen.exit()
	love.draw = oldfunctions.draw
	love.update = oldfunctions.update
	love.keypressed = oldfunctions.keypressed
	love.touchmoved = oldfunctions.touchmoved
	handleInput = oldfunctions.handleInput

	hajtech.titlemenu.exitsubmenu()
	hajtech.titlemenu.entermenu()
end

function gameendscreen.draw()
	hajtech.rendering.drawbegin()

	local imw, imh = image:getDimensions()
	love.graphics.draw(image, hajtech.rendering.width/2 - imw/2)

	love.graphics.setColor(0, 0, 0)
	local texty = 100
	local function writeline(text)
		love.graphics.printf(text, 0, texty, hajtech.rendering.width, 'center')
		texty = texty + 20
	end
	local formattime = hajtech.persistent.formattime

	writeline("Course times:")
	local totaltime = 0
	for course, time in pairs(hajtech.persistent.state.courserecords) do
		writeline(course .. ": " .. formattime(time))
		totaltime = totaltime + time
	end
	writeline("")

	writeline("Total time:")
	writeline(formattime(totaltime))
	writeline("")

	writeline("Total flasks found:")
	local totalflasks = 0
	for course, maps in pairs(hajtech.persistent.state.mapflasks) do
		for _, flasks in ipairs(maps) do
			totalflasks = totalflasks + flasks
		end
	end
	writeline(totalflasks)

	love.graphics.setColor(1, 1, 1)

	hajtech.rendering.drawend()
end

function gameendscreen.update(dt)
	countdown = countdown - dt
end

function gameendscreen.keypressed(key, scancode)
	if key == 'escape' or key == 'return' then
		gameendscreen.exit()
		return
	end
	oldfunctions.keypressed(key, scancode)
end

function gameendscreen.handleInput(playerid, action, prefix)
	if countdown < 0 then
		gameendscreen.exit()
	end
end

return gameendscreen
