local rendering = {}

function rendering.initialize(width, height)
	rendering.main_canvas = love.graphics.newCanvas(width, height)
	rendering.main_canvas:setFilter("linear", "nearest")
	rendering.width, rendering.height = rendering.main_canvas:getDimensions()
end

function rendering.drawbegin()
	love.graphics.setCanvas(rendering.main_canvas)
	love.graphics.clear({0, 0, 0})
end

function rendering.drawend()
	love.graphics.setCanvas()

	local width, height = love.graphics.getDimensions()
	local sx = width / rendering.width
	local sy = height / rendering.height
	if sx > 1 and sy > 1 then
		sx, sy = math.floor(sx), math.floor(sy)
	end
	sx = math.min(sx, sy)
	sy = sx
	local ox = (width - rendering.width*sx) / 2
	local oy = (height - rendering.height*sy) / 2
	ox, oy = math.floor(ox), math.floor(oy)

	love.graphics.draw(rendering.main_canvas, ox, oy, 0, sx, sy)
end

return rendering
